from typing import List, Dict, Tuple, Optional
import re
from objects import REG, DFA


class Parser:
    def __init__(self):
        pass

    # TODO ask: how should reg, dfa, ... look like?
    test_reg = "((S,A,B,C),(a,b,c),P,S) \
             P={S->a|aA|b, \
             A->c}"

    def reg_to_str(self, reg: REG) -> str:
        out = "(("
        for neterminal in reg.neterminals:
            if next:  # TODO
                out.append(",")
            out.append(neterminal)
        out.append("),(")
        for terminal in reg.terminals:
            if next:  # TODO
                out.append(",")
            out.append(terminal)
        out.append(",P," + reg.init + ")\nP=")
        out.append(rules_to_str(self, reg.rules))
        return out

        # Rules = Dict[Nonterminal, List[Tuple[Terminal, Optional[Nonterminal]]]]

    # TODO ask: from objects import rules (as type)?
    def rules_to_str(self, rules):
        out = "{"
        for rule in reg.rules:
            nonterminal, rewrite = rule
            if len(rewrite) == 0:
                continue

            out.append(nonterminal + "->")
            for variant in rewrite:
                for character in variant:
                    out.append(variant)
                if next:  # TODO
                    out.append("|")
                else:
                    out.append(",\n")

            return (out[:len(out) - 2] + "}")

    #    def str_to_reg(self, source: str) -> REG:
    #        re.match(...((nt),(t),P,S)\n rest

    test_dfa = "(0,a)=1\n(1,a)=0\nF={1}"

    def dfa_to_str(self, dfa: DFA, full=False) -> str:

        # full - verbose description of DFA - only for development, dismiss later
        
        states = "{"
        for state in dfa.states:
                states += state.name + ","
        states = states[:-1] + "}"
            
        terminals = "{"
        for state in dfa.terminals:
                terminals += state.name + ","
        terminals = terminals[:-1] + "}"

        transition = "{"
        for key, state_2 in dfa.transition.items():
            state_1, terminal = key
            transition += "(" + state_1.name + "," + terminal.name + ")=" + state_2.name + "\n"
        transition = transition[:-1] + "}"

        init = dfa.init.name

        final = "F={"
        for state in dfa.final:
            final += state.name + ","
        final = final[:-1] + "}"

        if full:
            return "DFA = (" + states + "," + terminals + ",d," + \
                  init + "," + final + ")\n" + "d = " + transition

        else:
            return transition + "\n" + final

# all: string <-> formal object
# reg
# dfa
# nfa
# pda
# cfg