from parser import Parser
from objects import Terminal, State, DFA


def test_dfa():
    q_0 = State("q_0")
    q_1 = State("q_1")
    a = Terminal("a")
    states = {q_0, q_1}
    init = q_0
    final = {q_0}
    terminals = {a}
    transition = dict()
    transition[q_0, a] = q_1
    transition[q_1, a] = q_1
    dfa = DFA(states, terminals, transition, init, final)
    print(dfa)
    return dfa


def main():
    dfa = test_dfa()
    parser = Parser()

    # test: dfa_to_str
    print(parser.dfa_to_str(dfa))
    print()
    print(parser.dfa_to_str(dfa, True))

    # test: add terminal, make total
    #print(len(dfa.transition))
    b = Terminal("b")
    dfa.terminals.add(b)
    tot_dfa = dfa.total()
    #print(len(dfa.transition))
    print(parser.dfa_to_str(tot_dfa, True))


main()